=== debian/changelog ===
syslinux (3:6.03+dfsg1-2) unstable; urgency=medium

  * Update 0004-gnu-efi.patch to use the jmp_buf definition from gnu-efi.
  * Add patch 0018-ext4-Fix-64bit-feature.patch from upstream to support ext4
    64bit feature (Closes: #833057).
  * Mark isolinux, pxelinux, syslinux-common and syslinux-efi as
    Multi-Arch: foreign.

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Tue, 17 Oct 2017 23:41:05 +0200

syslinux (3:6.03+dfsg1-1) unstable; urgency=low

  * Maintain syslinux in the debian-cd team (Closes: #805268).
    - Change Vcs-{Browser,Git} in debian/control accordingly.
    - Add debian/gbp.conf to set suitable defaults for git-buildpackage.
  * Add debian/watch file.
  * Implement repacking using uscan (add Files-Excluded field to
    debian/copyright and drop dfsg target in debian/rules).
  * New repack to remove build directories (bios, efi32, efi64) and
    gnu-efi/gnu-efi-3.0/debian from the source package.
  * Cleanup debian/rules: use debhelper config files more extensively.
  * Move to debhelper compatibility level 10, depend on debhelper 10.3 for
    dh_missing.
  * Add debian/clean to remove debris from build.
  * Update the variables passed to make for building:
    - Passing VERSION is no longer required.
    - Derive DATE from SOURCE_DATE_EPOCH.
    - Also pass HEXDATE derived from SOURCE_DATE_EPOCH.
  * Add patch to make the use SOURCE_DATE_EPOCH for the synthesized
    modification time constants.  This allows syslinux to build reproducibly
    as long as the build path stays the same.
  * Link efi binaries against gnu-efi from Debian:
    - Add Build-Depends-Indep on gnu-efi (an architecture independent
      dependency is necessary as gnu-efi is not available on x32).
    - Split the build in debian/rules for arch all/any packets so gnu-efi is
      not required for architecture specific builds.
    - Patch upstream's build system (by modifying 0004-gnu-efi.patch) to link
      against gnu-efi from Debian.
    - Record the static linking with gnu-efi (Built-Using control field).
  * Drop unused lintian overrides.
  * Add patch from upstream to fix btrfs logical to physical block address
    mapping (Closes: #865462).
  * Add patch from upstream to fix boot problem for old BIOS firmware from
    around 2005 by correcting the C/H/S order (thanks Thomas Schmitt).
  * Bump Standards-Version to 4.1.1.

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Sat, 07 Oct 2017 17:48:54 +0200
