=== debian/changelog ===
syslinux (3:6.03+git20161205-0) mx; urgency=medium

  * Build from git to incorporate fix for memtest

 -- Timothy E. Harris <maintainer@mepiscommunity.org>  Tue, 06 Dec 2016 14:30:15 -0500
