## syslinux 6.04~git20171011.af7e95c3+dfsg1

=== debian/changelog ===
syslinux (3:6.04~git20171011.af7e95c3+dfsg1-6) unstable; urgency=medium

  * gnu-efi compatibility patch: use memset and memcpy from syslinux instead
    of from gnu-efi
    - Using the memset and memcpy from gnu-efi causes some modules (e.g.
      vesamenu.c32) to fail with "Undef symbol FAIL: memset"

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Mon, 03 Dec 2018 22:45:42 +0100

syslinux (3:6.04~git20171011.af7e95c3+dfsg1-5) unstable; urgency=medium

  * Build against gnu-efi >= 3.0.8
  * Bump Standards-Version to 4.2.1.

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Sat, 13 Oct 2018 11:14:54 +0200

syslinux (3:6.04~git20171011.af7e95c3+dfsg1-4) unstable; urgency=medium

  * Point Vcs-Git and Vcs-Browser to salsa.debian.org.
  * Revert the gnu-efi patch again so that syslinux can be built against
    gnu-efi 3.0.4 from buster.
  * Strip .note.gnu.property section from mbr.bin (added since
    binutils >= 2.31.1-2) to stay within size constraints (Closes: #906414).
  * Fix broken efi binaries when building with binutils >= 2.31 by patching
    the linker script.
  * Bump Standards-Version to 4.2.0.
  * Move to debhelper compatibility level 11.

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Sat, 18 Aug 2018 17:45:42 +0200

syslinux (3:6.04~git20171011.af7e95c3+dfsg1-3) experimental; urgency=medium

  * Do not create -dbgsym packages for now, as they do not contain any debug
    symbols due to the way syslinux is compiled.
  * Clean up obsolete configuration files in /etc/kernel that are no longer
    present in extlinux since Debian jessie but have never been properly
    removed (Closes: #866343).
  * Build against gnu-efi >= 3.0.6:
    - Split the gnu-efi patch into Debian-specific and non-Debian-specific.
    - Add necessary patches from upstream's mailing list.
    - Adjust the Build-Dependencies.

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Sun, 03 Dec 2017 11:13:37 +0100

syslinux (3:6.04~git20171011.af7e95c3+dfsg1-2) experimental; urgency=medium

  * Extend 0009-reproducible-build.patch: Also sort file lists obtained using
    `find`, so they are passed to `ar` in a deterministic order.

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Sat, 04 Nov 2017 11:52:54 +0100

syslinux (3:6.04~git20171011.af7e95c3+dfsg1-1) experimental; urgency=medium

  * Import new version (upstream's current git state, prerelease of
    syslinux 6.04).
    - Booting from XFS now works in MBR partition schemes (Closes: #803938).
  * Remove gnu-efi from the source package so it's not used accidentally.
  * Drop patches included upstream:
    - 0005-load-linux-correct-type.patch
    - 0006-load-linux-protected-mode.patch
    - 0007-sysappend-fix-space-stripping.patch
    - 0008-Fix-gcc-5-ALIGN-causing-Boot-error.patch
    - 0010-fix-ftbfs-with-default-pie.patch
    - 0011-bios-Dont-try-to-guess-the-section-alignment.patch
    - 0012-ldlinux-Fix-return-pointer-to-local-data.patch
    - 0013-extlinux-pull-in-sys_sysmacros.h-for-major_minor_makedev.patch
    - 0016-btrfs-fix.patch
    - 0017-isohdpfx.S-correct-heads-sectors.patch
    - 0018-ext4-Fix-64bit-feature.patch
  * Update patches:
    - 0009-reproducible-build.patch: Drop parts that are included upstream.
    - 0004-gnu-efi.patch: Drop parts that have become unnecessary, because
      upstream checks for a .git directory before trying to update submodules.
  * Remove 0014_fix_ftbfs_no_dynamic_linker.patch which isn't required any
    longer.
  * Improve the extlinux man page (update 0003-extlinux-manpage.patch).
  * Refresh all patches.
  * Add special purpose and debugging MBRs to syslinux-common and isolinux
    packages.
  * Patch upstream changelog to include changes since 6.03.
  * Update debian/copyright as needed.

 -- Lukas Schwaighofer <lukas@schwaighofer.name>  Thu, 02 Nov 2017 08:51:50 +0100
