=== debian/control ===
--- 
+++ 
@@ -4,18 +4,18 @@
 Maintainer: Debian CD Group <debian-cd@lists.debian.org>
 Uploaders: Lukas Schwaighofer <lukas@schwaighofer.name>
 Build-Depends:
- debhelper (>= 10.3),
+ debhelper (>= 11),
  e2fslibs-dev,
  gcc-multilib [amd64 x32],
  libc6-dev-i386 [amd64 x32],
  nasm,
  python,
  uuid-dev,
-Build-Depends-Indep: gnu-efi
-Standards-Version: 4.1.1
+Build-Depends-Indep: gnu-efi (>= 3.0.8)
+Standards-Version: 4.2.1
 Homepage: http://www.syslinux.org/
-Vcs-Git: https://anonscm.debian.org/git/debian-cd/syslinux.git
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-cd/syslinux.git
+Vcs-Git: https://salsa.debian.org/images-team/syslinux.git
+Vcs-Browser: https://salsa.debian.org/images-team/syslinux
 
 Package: syslinux
 Architecture: amd64 i386 x32
